const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const stock_movements = sequelize.define(
    'stock_movements',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

moved_at: {
        type: DataTypes.DATE,
      
      

      },

movement_type: {
        type: DataTypes.ENUM,
      
      

        values: [

"purchase_reception",


"sale_delivery",


"reservation",


"unreservation",


"inventory_adjustment",


"manual_in",


"manual_out",


"transfer_in",


"transfer_out",


"credit_note_return"

        ],

      },

quantity: {
        type: DataTypes.DECIMAL,
      
      

      },

unit_cost_ht: {
        type: DataTypes.DECIMAL,
      
      

      },

reference: {
        type: DataTypes.TEXT,
      
      

      },

notes: {
        type: DataTypes.TEXT,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  stock_movements.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity






































//end loop



    db.stock_movements.belongsTo(db.organizations, {
      as: 'organization',
      foreignKey: {
        name: 'organizationId',
      },
      constraints: false,
    });

    db.stock_movements.belongsTo(db.products, {
      as: 'product',
      foreignKey: {
        name: 'productId',
      },
      constraints: false,
    });

    db.stock_movements.belongsTo(db.warehouses, {
      as: 'warehouse',
      foreignKey: {
        name: 'warehouseId',
      },
      constraints: false,
    });




    db.stock_movements.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.stock_movements.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return stock_movements;
};


